#include "bits/stdc++.h"

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define rep1(i, n) for (int i = 1; i < (n); ++i)
#define rep1n(i, n) for (int i = 1; i <= (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define pb push_back
#define eb emplace_back
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define each(x, a) for (auto &x : a)
#define ar array
#define vec vector
#define range(i, n) rep(i, n)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;

using vi = vector<int>;
using vl = vector<ll>;
using vpl = vector<pl>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;

int Bit(int mask, int b) { return (mask >> b) & 1; }

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INFi = 2e9;
const ll INF = 2e18;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vi a(n);
    rep(i, n) cin >> a[i];
    vector<int> jump(n);
    map<int, int> cnt;
    int R = 0;
    int unq = 0;
    for (int i = 0; i < n; ++i) {
        while (R < n + i) {
            int x = a[R%n];
            if (cnt[x] == 0 && unq == t) break;
            cnt[x]++;
            if (cnt[x] == 1) unq++;
            R++;
        }
        jump[i] = R % n;
        cnt[a[i]]--;
        if (cnt[a[i]] == 0) unq--;
    }
    if (!jump[0]) {
        cout << "1\n";
        return;
    }
    int cur = 0;
    ll ans = 0;
    while (k) {
        ans++;
        if (jump[cur] <= cur) k--;
        cur = jump[cur];
    }
    cout << ans << '\n';
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    int t = 1;
    rep(_, t) {
        solve();
    }
    return 0;
}
