#include <bits/stdc++.h>

#include <algorithm>
#include <cmath>
#include <ctime>
#include <functional>
#include <iomanip>
#include <ios>
#include <queue>
#include <random>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;
typedef double db;
typedef unsigned long long ull;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void decrease_key(map<int, int>& mp, int key) {
    mp[key]--;
    if (mp[key] == 0) {
        mp.erase(key);
    }
}

void count_dp(int n, int k, int t, vector<pair<int, int>>& dp, vector<int>& doubled) {
    map<int, int> cnt;
    for (int l = n - 1; l >= 0; --l) {
        int r = l;
        while (cnt.size() <= t && r < 2 * n) {
            cnt[doubled[r]]++;
            ++r;
        }
        if (r == 2 * n) {
            cout << 1;
            exit(0);
        }
        r -= 2;
        if (r >= n - 1) {
            dp[l] = {r + 1, 1};
        } else {
            dp[l] = {dp[r + 1].first, dp[r + 1].second + 1};
        }
        cnt.clear();
    }
}

ll count_ans(int n, int k, vector<pair<int, int>>& dp) {
    ll count = 0;
    int st = 0;
    for (int c = 0; c < k - 1; ++c) {
        count += dp[st].second;
        st = dp[st].first % n;
    }
    count += dp[st].second;
    return count;
}

int main() {
    fast_io();
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (auto& i : a) {
        cin >> i;
    }
    vector<pair<int, int>> dp(n);
    vector<int> doubled(n * 2);
    for (int i = 0; i < 2 * n; ++i) {
        doubled[i] = a[i % n];
    }
    count_dp(n, k, t, dp, doubled);
    cout << count_ans(n, k, dp);
}
