#include <bits/stdc++.h>

#include <random>

#include "testlib.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;
typedef double db;
typedef unsigned long long ull;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        if (params[name].find('e') != string::npos) {
            return (long long)(stod(params[name]));
        }
        return stoll(params[name]);
    } else {
        return def;
    }
}

signed main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    fast_io();
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }
    int maxa = get("maxa", 1e9);
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (auto& i : a) {
        cin >> i;
    }
    map<int, int> mp;
    set<int> used;
    for (int i = 0; i < n; ++i) {
        if (!mp.count(a[i])) {
            int x = rnd.next(1, maxa);
            while (used.count(x)) {
                x = rnd.next(1, maxa);
            }
            mp[a[i]] = x;
            used.emplace(x);
        }
    }
    cout << n << " " << k << " " << t << '\n';
    for (int i = 0; i < n; ++i) {
        cout << mp[a[i]];
        if (i != n - 1) {
            cout << " ";
        }
    }
    cout << '\n';
    return 0;
}
