def add_key(cnt: dict, value: int) -> None:
    if (value in cnt):
        cnt[value] += 1
    else:
        cnt[value] = 1
    pass

def decrease_key(cnt: dict, value: int) -> None:
    cnt[value] -= 1
    if (cnt[value] == 0):
        cnt.pop(value)

def count_dp(n: int, k: int, t: int) -> None:
    cnt = dict()
    for l in range(n - 1, -1, -1):
        r = l
        while len(cnt) <= t and r < 2 * n:
            add_key(cnt, doubled[r])
            r += 1
        if r == 2 * n:
            print(1)
            exit(0)
        r -= 2
        if r >= n - 1:
            dp[l] = (r + 1, 1)
        else:
            dp[l] = (dp[r + 1][0], dp[r + 1][1] + 1)
        cnt.clear()
    pass
        
def count_ans() -> int:
    count = 0
    st = 0
    for c in range(0, k):
        count += dp[st][1]
        st = dp[st][0] % n
    return count

n, k, t = map(int, input().split())
a = list(map(int, input().split()))

doubled = a + a
dp = dict()

count_dp(n, k, t)

print(count_ans())
